/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSDOMRectReadOnly.h"

#include "ActiveDOMObject.h"
#include "DOMIsoSubspaces.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructor.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMRectInit.h"
#include "JSDOMRectReadOnly.h"
#include "JSDOMWrapperCache.h"
#include "ScriptExecutionContext.h"
#include "WebCoreJSClientData.h"
#include <JavaScriptCore/FunctionPrototype.h>
#include <JavaScriptCore/HeapAnalyzer.h>
#include <JavaScriptCore/JSCInlines.h>
#include <JavaScriptCore/JSDestructibleObjectHeapCellType.h>
#include <JavaScriptCore/ObjectConstructor.h>
#include <JavaScriptCore/SlotVisitorMacros.h>
#include <JavaScriptCore/SubspaceInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/PointerPreparations.h>
#include <wtf/URL.h>


namespace WebCore {
using namespace JSC;

// Functions

static JSC_DECLARE_HOST_FUNCTION(jsDOMRectReadOnlyConstructorFunction_fromRect);
static JSC_DECLARE_HOST_FUNCTION(jsDOMRectReadOnlyPrototypeFunction_toJSON);

// Attributes

static JSC_DECLARE_CUSTOM_GETTER(jsDOMRectReadOnlyConstructor);
static JSC_DECLARE_CUSTOM_GETTER(jsDOMRectReadOnly_x);
static JSC_DECLARE_CUSTOM_GETTER(jsDOMRectReadOnly_y);
static JSC_DECLARE_CUSTOM_GETTER(jsDOMRectReadOnly_width);
static JSC_DECLARE_CUSTOM_GETTER(jsDOMRectReadOnly_height);
static JSC_DECLARE_CUSTOM_GETTER(jsDOMRectReadOnly_top);
static JSC_DECLARE_CUSTOM_GETTER(jsDOMRectReadOnly_right);
static JSC_DECLARE_CUSTOM_GETTER(jsDOMRectReadOnly_bottom);
static JSC_DECLARE_CUSTOM_GETTER(jsDOMRectReadOnly_left);

class JSDOMRectReadOnlyPrototype final : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSDOMRectReadOnlyPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSDOMRectReadOnlyPrototype* ptr = new (NotNull, JSC::allocateCell<JSDOMRectReadOnlyPrototype>(vm.heap)) JSDOMRectReadOnlyPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    template<typename CellType, JSC::SubspaceAccess>
    static JSC::IsoSubspace* subspaceFor(JSC::VM& vm)
    {
        STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSDOMRectReadOnlyPrototype, Base);
        return &vm.plainObjectSpace;
    }
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSDOMRectReadOnlyPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};
STATIC_ASSERT_ISO_SUBSPACE_SHARABLE(JSDOMRectReadOnlyPrototype, JSDOMRectReadOnlyPrototype::Base);

using JSDOMRectReadOnlyDOMConstructor = JSDOMConstructor<JSDOMRectReadOnly>;

/* Hash table for constructor */

static const HashTableValue JSDOMRectReadOnlyConstructorTableValues[] =
{
    { "fromRect", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsDOMRectReadOnlyConstructorFunction_fromRect), (intptr_t) (0) } },
};

template<> EncodedJSValue JSC_HOST_CALL_ATTRIBUTES JSDOMRectReadOnlyDOMConstructor::construct(JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame)
{
    VM& vm = lexicalGlobalObject->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* castedThis = jsCast<JSDOMRectReadOnlyDOMConstructor*>(callFrame->jsCallee());
    ASSERT(castedThis);
    EnsureStillAliveScope argument0 = callFrame->argument(0);
    auto x = argument0.value().isUndefined() ? 0 : convert<IDLUnrestrictedDouble>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument1 = callFrame->argument(1);
    auto y = argument1.value().isUndefined() ? 0 : convert<IDLUnrestrictedDouble>(*lexicalGlobalObject, argument1.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument2 = callFrame->argument(2);
    auto width = argument2.value().isUndefined() ? 0 : convert<IDLUnrestrictedDouble>(*lexicalGlobalObject, argument2.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    EnsureStillAliveScope argument3 = callFrame->argument(3);
    auto height = argument3.value().isUndefined() ? 0 : convert<IDLUnrestrictedDouble>(*lexicalGlobalObject, argument3.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    auto object = DOMRectReadOnly::create(WTFMove(x), WTFMove(y), WTFMove(width), WTFMove(height));
    static_assert(TypeOrExceptionOrUnderlyingType<decltype(object)>::isRef);
    auto jsValue = toJSNewlyCreated<IDLInterface<DOMRectReadOnly>>(*lexicalGlobalObject, *castedThis->globalObject(), throwScope, WTFMove(object));
    if constexpr (IsExceptionOr<decltype(object)>)
        RETURN_IF_EXCEPTION(throwScope, { });
    setSubclassStructureIfNeeded<DOMRectReadOnly>(lexicalGlobalObject, callFrame, asObject(jsValue));
    RETURN_IF_EXCEPTION(throwScope, { });
    return JSValue::encode(jsValue);
}
JSC_ANNOTATE_HOST_FUNCTION(JSDOMRectReadOnlyDOMConstructorConstruct, JSDOMRectReadOnlyDOMConstructor::construct);

template<> JSValue JSDOMRectReadOnlyDOMConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSDOMRectReadOnlyDOMConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSDOMRectReadOnly::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(vm, "DOMRectReadOnly"_s), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    reifyStaticProperties(vm, JSDOMRectReadOnly::info(), JSDOMRectReadOnlyConstructorTableValues, *this);
}

template<> const ClassInfo JSDOMRectReadOnlyDOMConstructor::s_info = { "DOMRectReadOnly", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSDOMRectReadOnlyDOMConstructor) };

/* Hash table for prototype */

static const HashTableValue JSDOMRectReadOnlyPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMRectReadOnlyConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "x", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMRectReadOnly_x), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "y", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMRectReadOnly_y), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "width", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMRectReadOnly_width), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "height", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMRectReadOnly_height), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "top", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMRectReadOnly_top), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "right", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMRectReadOnly_right), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "bottom", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMRectReadOnly_bottom), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "left", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsDOMRectReadOnly_left), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "toJSON", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<RawNativeFunction>(jsDOMRectReadOnlyPrototypeFunction_toJSON), (intptr_t) (0) } },
};

const ClassInfo JSDOMRectReadOnlyPrototype::s_info = { "DOMRectReadOnly", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSDOMRectReadOnlyPrototype) };

void JSDOMRectReadOnlyPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSDOMRectReadOnly::info(), JSDOMRectReadOnlyPrototypeTableValues, *this);
    JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
}

const ClassInfo JSDOMRectReadOnly::s_info = { "DOMRectReadOnly", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSDOMRectReadOnly) };

JSDOMRectReadOnly::JSDOMRectReadOnly(Structure* structure, JSDOMGlobalObject& globalObject, Ref<DOMRectReadOnly>&& impl)
    : JSDOMWrapper<DOMRectReadOnly>(structure, globalObject, WTFMove(impl))
{
}

void JSDOMRectReadOnly::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

    static_assert(!std::is_base_of<ActiveDOMObject, DOMRectReadOnly>::value, "Interface is not marked as [ActiveDOMObject] even though implementation class subclasses ActiveDOMObject.");

}

JSObject* JSDOMRectReadOnly::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSDOMRectReadOnlyPrototype::create(vm, &globalObject, JSDOMRectReadOnlyPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSDOMRectReadOnly::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSDOMRectReadOnly>(vm, globalObject);
}

JSValue JSDOMRectReadOnly::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSDOMRectReadOnlyDOMConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSDOMRectReadOnly::destroy(JSC::JSCell* cell)
{
    JSDOMRectReadOnly* thisObject = static_cast<JSDOMRectReadOnly*>(cell);
    thisObject->JSDOMRectReadOnly::~JSDOMRectReadOnly();
}

template<> inline JSDOMRectReadOnly* IDLAttribute<JSDOMRectReadOnly>::cast(JSGlobalObject& lexicalGlobalObject, EncodedJSValue thisValue)
{
    return jsDynamicCast<JSDOMRectReadOnly*>(JSC::getVM(&lexicalGlobalObject), JSValue::decode(thisValue));
}

template<> inline JSDOMRectReadOnly* IDLOperation<JSDOMRectReadOnly>::cast(JSGlobalObject& lexicalGlobalObject, CallFrame& callFrame)
{
    return jsDynamicCast<JSDOMRectReadOnly*>(JSC::getVM(&lexicalGlobalObject), callFrame.thisValue());
}

JSC_DEFINE_CUSTOM_GETTER(jsDOMRectReadOnlyConstructor, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    VM& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicCast<JSDOMRectReadOnlyPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(lexicalGlobalObject, throwScope);
    return JSValue::encode(JSDOMRectReadOnly::getConstructor(JSC::getVM(lexicalGlobalObject), prototype->globalObject()));
}

static inline JSValue jsDOMRectReadOnly_xGetter(JSGlobalObject& lexicalGlobalObject, JSDOMRectReadOnly& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnrestrictedDouble>(lexicalGlobalObject, throwScope, impl.x())));
}

JSC_DEFINE_CUSTOM_GETTER(jsDOMRectReadOnly_x, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSDOMRectReadOnly>::get<jsDOMRectReadOnly_xGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "x");
}

static inline JSValue jsDOMRectReadOnly_yGetter(JSGlobalObject& lexicalGlobalObject, JSDOMRectReadOnly& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnrestrictedDouble>(lexicalGlobalObject, throwScope, impl.y())));
}

JSC_DEFINE_CUSTOM_GETTER(jsDOMRectReadOnly_y, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSDOMRectReadOnly>::get<jsDOMRectReadOnly_yGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "y");
}

static inline JSValue jsDOMRectReadOnly_widthGetter(JSGlobalObject& lexicalGlobalObject, JSDOMRectReadOnly& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnrestrictedDouble>(lexicalGlobalObject, throwScope, impl.width())));
}

JSC_DEFINE_CUSTOM_GETTER(jsDOMRectReadOnly_width, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSDOMRectReadOnly>::get<jsDOMRectReadOnly_widthGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "width");
}

static inline JSValue jsDOMRectReadOnly_heightGetter(JSGlobalObject& lexicalGlobalObject, JSDOMRectReadOnly& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnrestrictedDouble>(lexicalGlobalObject, throwScope, impl.height())));
}

JSC_DEFINE_CUSTOM_GETTER(jsDOMRectReadOnly_height, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSDOMRectReadOnly>::get<jsDOMRectReadOnly_heightGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "height");
}

static inline JSValue jsDOMRectReadOnly_topGetter(JSGlobalObject& lexicalGlobalObject, JSDOMRectReadOnly& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnrestrictedDouble>(lexicalGlobalObject, throwScope, impl.top())));
}

JSC_DEFINE_CUSTOM_GETTER(jsDOMRectReadOnly_top, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSDOMRectReadOnly>::get<jsDOMRectReadOnly_topGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "top");
}

static inline JSValue jsDOMRectReadOnly_rightGetter(JSGlobalObject& lexicalGlobalObject, JSDOMRectReadOnly& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnrestrictedDouble>(lexicalGlobalObject, throwScope, impl.right())));
}

JSC_DEFINE_CUSTOM_GETTER(jsDOMRectReadOnly_right, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSDOMRectReadOnly>::get<jsDOMRectReadOnly_rightGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "right");
}

static inline JSValue jsDOMRectReadOnly_bottomGetter(JSGlobalObject& lexicalGlobalObject, JSDOMRectReadOnly& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnrestrictedDouble>(lexicalGlobalObject, throwScope, impl.bottom())));
}

JSC_DEFINE_CUSTOM_GETTER(jsDOMRectReadOnly_bottom, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSDOMRectReadOnly>::get<jsDOMRectReadOnly_bottomGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "bottom");
}

static inline JSValue jsDOMRectReadOnly_leftGetter(JSGlobalObject& lexicalGlobalObject, JSDOMRectReadOnly& thisObject)
{
    auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto& impl = thisObject.wrapped();
    RELEASE_AND_RETURN(throwScope, (toJS<IDLUnrestrictedDouble>(lexicalGlobalObject, throwScope, impl.left())));
}

JSC_DEFINE_CUSTOM_GETTER(jsDOMRectReadOnly_left, (JSGlobalObject* lexicalGlobalObject, EncodedJSValue thisValue, PropertyName))
{
    return IDLAttribute<JSDOMRectReadOnly>::get<jsDOMRectReadOnly_leftGetter, CastedThisErrorBehavior::Assert>(*lexicalGlobalObject, thisValue, "left");
}

static inline JSC::EncodedJSValue jsDOMRectReadOnlyConstructorFunction_fromRectBody(JSC::JSGlobalObject* lexicalGlobalObject, JSC::CallFrame* callFrame)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(callFrame);
    EnsureStillAliveScope argument0 = callFrame->argument(0);
    auto other = convert<IDLDictionary<DOMRectInit>>(*lexicalGlobalObject, argument0.value());
    RETURN_IF_EXCEPTION(throwScope, encodedJSValue());
    RELEASE_AND_RETURN(throwScope, JSValue::encode(toJSNewlyCreated<IDLInterface<DOMRectReadOnly>>(*lexicalGlobalObject, *jsCast<JSDOMGlobalObject*>(lexicalGlobalObject), DOMRectReadOnly::fromRect(WTFMove(other)))));
}

JSC_DEFINE_HOST_FUNCTION(jsDOMRectReadOnlyConstructorFunction_fromRect, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSDOMRectReadOnly>::callStatic<jsDOMRectReadOnlyConstructorFunction_fromRectBody>(*lexicalGlobalObject, *callFrame, "fromRect");
}

static inline EncodedJSValue jsDOMRectReadOnlyPrototypeFunction_toJSONBody(JSGlobalObject* lexicalGlobalObject, CallFrame*, JSDOMRectReadOnly* castedThis)
{
    auto& vm = JSC::getVM(lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    auto* result = constructEmptyObject(lexicalGlobalObject, castedThis->globalObject()->objectPrototype());
    result->putDirect(vm, Identifier::fromString(vm, "x"), toJS<IDLUnrestrictedDouble>(*lexicalGlobalObject, throwScope, impl.x()));
    result->putDirect(vm, Identifier::fromString(vm, "y"), toJS<IDLUnrestrictedDouble>(*lexicalGlobalObject, throwScope, impl.y()));
    result->putDirect(vm, Identifier::fromString(vm, "width"), toJS<IDLUnrestrictedDouble>(*lexicalGlobalObject, throwScope, impl.width()));
    result->putDirect(vm, Identifier::fromString(vm, "height"), toJS<IDLUnrestrictedDouble>(*lexicalGlobalObject, throwScope, impl.height()));
    result->putDirect(vm, Identifier::fromString(vm, "top"), toJS<IDLUnrestrictedDouble>(*lexicalGlobalObject, throwScope, impl.top()));
    result->putDirect(vm, Identifier::fromString(vm, "right"), toJS<IDLUnrestrictedDouble>(*lexicalGlobalObject, throwScope, impl.right()));
    result->putDirect(vm, Identifier::fromString(vm, "bottom"), toJS<IDLUnrestrictedDouble>(*lexicalGlobalObject, throwScope, impl.bottom()));
    result->putDirect(vm, Identifier::fromString(vm, "left"), toJS<IDLUnrestrictedDouble>(*lexicalGlobalObject, throwScope, impl.left()));
    return JSValue::encode(result);
}

JSC_DEFINE_HOST_FUNCTION(jsDOMRectReadOnlyPrototypeFunction_toJSON, (JSGlobalObject* lexicalGlobalObject, CallFrame* callFrame))
{
    return IDLOperation<JSDOMRectReadOnly>::call<jsDOMRectReadOnlyPrototypeFunction_toJSONBody>(*lexicalGlobalObject, *callFrame, "toJSON");
}

JSC::IsoSubspace* JSDOMRectReadOnly::subspaceForImpl(JSC::VM& vm)
{
    auto& clientData = *static_cast<JSVMClientData*>(vm.clientData);
    auto& spaces = clientData.subspaces();
    if (auto* space = spaces.m_subspaceForDOMRectReadOnly.get())
        return space;
    static_assert(std::is_base_of_v<JSC::JSDestructibleObject, JSDOMRectReadOnly> || !JSDOMRectReadOnly::needsDestruction);
    if constexpr (std::is_base_of_v<JSC::JSDestructibleObject, JSDOMRectReadOnly>)
        spaces.m_subspaceForDOMRectReadOnly = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.destructibleObjectHeapCellType.get(), JSDOMRectReadOnly);
    else
        spaces.m_subspaceForDOMRectReadOnly = makeUnique<IsoSubspace> ISO_SUBSPACE_INIT(vm.heap, vm.cellHeapCellType.get(), JSDOMRectReadOnly);
    auto* space = spaces.m_subspaceForDOMRectReadOnly.get();
IGNORE_WARNINGS_BEGIN("unreachable-code")
IGNORE_WARNINGS_BEGIN("tautological-compare")
    void (*myVisitOutputConstraint)(JSC::JSCell*, JSC::SlotVisitor&) = JSDOMRectReadOnly::visitOutputConstraints;
    void (*jsCellVisitOutputConstraint)(JSC::JSCell*, JSC::SlotVisitor&) = JSC::JSCell::visitOutputConstraints;
    if (myVisitOutputConstraint != jsCellVisitOutputConstraint)
        clientData.outputConstraintSpaces().append(space);
IGNORE_WARNINGS_END
IGNORE_WARNINGS_END
    return space;
}

void JSDOMRectReadOnly::analyzeHeap(JSCell* cell, HeapAnalyzer& analyzer)
{
    auto* thisObject = jsCast<JSDOMRectReadOnly*>(cell);
    analyzer.setWrappedObjectForCell(cell, &thisObject->wrapped());
    if (thisObject->scriptExecutionContext())
        analyzer.setLabelForCell(cell, "url " + thisObject->scriptExecutionContext()->url().string());
    Base::analyzeHeap(cell, analyzer);
}

bool JSDOMRectReadOnlyOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, AbstractSlotVisitor& visitor, const char** reason)
{
    auto* jsDOMRectReadOnly = jsCast<JSDOMRectReadOnly*>(handle.slot()->asCell());
    DOMRectReadOnly* root = &jsDOMRectReadOnly->wrapped();
    if (UNLIKELY(reason))
        *reason = "Reachable from DOMRectReadOnly";
    return visitor.containsOpaqueRoot(root);
}

void JSDOMRectReadOnlyOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsDOMRectReadOnly = static_cast<JSDOMRectReadOnly*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsDOMRectReadOnly->wrapped(), jsDOMRectReadOnly);
}

JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject* globalObject, Ref<DOMRectReadOnly>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to DOMRectReadOnly.
    static_assert(!std::is_polymorphic<DOMRectReadOnly>::value, "DOMRectReadOnly is polymorphic but the IDL claims it is not");
    return createWrapper<DOMRectReadOnly>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, DOMRectReadOnly& impl)
{
    return wrap(lexicalGlobalObject, globalObject, impl);
}

DOMRectReadOnly* JSDOMRectReadOnly::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicCast<JSDOMRectReadOnly*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
